diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
similarity index 56%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index d9278d4a5..7696d6599 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Font;
@@ -10,13 +10,13 @@ import net.minecraft.client.render.model.ModelZombie;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
-import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 {
@@ -24,69 +24,62 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
     private final Minecraft mc = Minecraft.getMinecraft();
     private final ModelSign modelSign;
 
-
     public TileEntityRendererSign()
     {
         modelSign = new ModelSign();
     }
 
-    public void renderTileEntitySignAt(TileEntitySign tileEntity, double d, double d1, double d2,
-                                       float f)
+     @Override
+	public void doRender(Tessellator tessellator, TileEntitySign tileEntity, double x, double y, double z,
+                         float partialTick)
     {
-        Block<?> block = tileEntity.getBlock();
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
-        float scale = 0.6666667F;
-        if(block == Blocks.SIGN_POST_PLANKS_OAK)
-        {
-            GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
-            float f2 = (float)(tileEntity.getBlockMeta() * 360) / 16F;
-            GL11.glRotatef(-f2, 0.0F, 1.0F, 0.0F);
+        float scale = 2/3f;
+        GL11.glTranslatef((float)x + 0.5F, (float)y + 0.75F * scale, (float)z + 0.5F);
+        if (((BlockLogicSign) tileEntity.getBlock().getLogic()).isFreeStanding) {
+            float angle = (float)(tileEntity.getBlockMeta() * 360) / 16F;
+            GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
             modelSign.signStick.visible = true;
-        }
-        else
-        {
-            int i = tileEntity.getBlockMeta();
-            float f3 = 0.0F;
-            if(i == 2)
-            {
-                f3 = 180F;
-            }
-            if(i == 4)
-            {
-                f3 = 90F;
-            }
-            if(i == 5)
-            {
-                f3 = -90F;
+        } else {
+            float angle;
+            switch (tileEntity.getBlockMeta()) {
+                case BlockLogicSign.SIDE_NORTH:
+                    angle = 180F;
+                    break;
+                case BlockLogicSign.SIDE_SOUTH:
+                    angle = 0.0F;
+                    break;
+                case BlockLogicSign.SIDE_WEST:
+                    angle = 90F;
+                    break;
+                case BlockLogicSign.SIDE_EAST:
+                default:
+                    angle = -90F;
+                    break;
             }
-           /*GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
-            GL11.glRotatef(-f3, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -0.3125F, -0.825F);*/
-            GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
-            GL11.glRotatef(-f3, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
             GL11.glTranslatef(0.0F, -0.3125F, -0.4375F);
             modelSign.signStick.visible = false;
         }
-        loadTexture("/assets/minecraft/textures/entity/sign.png");
+
         GL11.glPushMatrix();
         GL11.glScalef(scale, -scale, -scale);
+        loadTexture("/assets/minecraft/textures/entity/sign.png");
         modelSign.render();
         GL11.glPopMatrix();
-        Font font = getFont();
 
         // Render overlay
         GL11.glPushMatrix();
-        float f4 = 0.01566F * scale;
-        GL11.glTranslatef(0.0F, 0.5F * scale, 0.065F * scale);
-        GL11.glScalef(f4, -f4, f4);
-        GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
+        GL11.glTranslatef(0, 5.3672f/16f, 0.7f/16f);
         GL11.glDepthMask(false);
         EnumSignPicture picture = tileEntity.getPicture();
-        drawTexturedModalRect(-48, -24, 48, 24, TextureRegistry.getTexture(picture.getTextureKey()));
+        drawTexturedModalRect(1, 0.5,TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
 
         // Render text
-        float lightLevel = mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        Font font = getFont();
+        float lightLevel = LightmapHelper.isLightmapEnabled() ? 1 : mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
             lightLevel = 1f;
@@ -98,13 +91,12 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         }
 
         GL11.glPushMatrix();
-        f4 = 0.01666667F * scale;
+        float scale2 = 0.01666667F * scale;
         GL11.glTranslatef(0.0F, 0.5F * scale, 0.065F * scale);
-        GL11.glScalef(f4, -f4, f4);
-        GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
+        GL11.glScalef(scale2, -scale2, scale2);
         GL11.glDepthMask(false);
         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
-        int r = (int)MathHelper.clamp(((color >> 16) & 0xFF) * lightLevel + lightOffset, 0, 255);
+        int r = (int) MathHelper.clamp(((color >> 16) & 0xFF) * lightLevel + lightOffset, 0, 255);
         int g = (int)MathHelper.clamp(((color >>  8) & 0xFF) * lightLevel + lightOffset, 0, 255);
         int b = (int)MathHelper.clamp(((color >>  0) & 0xFF) * lightLevel + lightOffset, 0, 255);
         color = (r << 16) | (g << 8) | (b << 0);
@@ -122,24 +114,18 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glDepthMask(true);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glPopMatrix();
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    @Override
-	public void doRender(Tessellator tessellator, TileEntitySign tileEntity, double x, double y, double z,
-                         float partialTick)
-    {
-        renderTileEntitySignAt(tileEntity, x, y, z, partialTick);
-    }
-
-    private void drawTexturedModalRect(int x, int y, int width, int height, IconCoordinate coordinate)
+    private void drawTexturedModalRect(double width, double height, IconCoordinate coordinate)
     {
         coordinate.parentAtlas.bind();
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0,          y + height * 2, 0, coordinate.getIconUMin(),coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width * 2,  y + height * 2, 0, coordinate.getIconUMax(),coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width * 2,  y + 0,          0, coordinate.getIconUMax(),coordinate.getIconVMin());
-        tessellator.addVertexWithUV(x + 0,          y + 0,          0, coordinate.getIconUMin(),coordinate.getIconVMin());
+        tessellator.addVertexWithUV(-width/2,  height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMin());
+        tessellator.addVertexWithUV(-width/2, -height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMax());
+        tessellator.addVertexWithUV( width/2, -height/2, 0, coordinate.getIconUMax(),coordinate.getIconVMax());
+        tessellator.addVertexWithUV( width/2,  height/2, 0, coordinate.getIconUMax(),coordinate.getIconVMin());
         tessellator.draw();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
similarity index 50%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index be550f04f..1f0593d94 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -1,46 +1,99 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
+import net.minecraft.client.render.model.ModelPigman;
 import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityStatue;
+import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.*;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
+
+import java.util.HashMap;
+import java.util.Map;
 
 public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatue> {
+    public static final @NotNull Map<@NotNull Block<?>, @NotNull String> BLOCK_SKIN_MAP = new HashMap<>();
+    static {
+        final @NotNull String basePath = "/assets/minecraft/textures/entity/statue/";
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_STONE_LOWER, basePath + "stone.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_BASALT_LOWER, basePath + "basalt.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_LIMESTONE_LOWER, basePath + "limestone.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_GRANITE_LOWER, basePath + "granite.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_MARBLE_LOWER, basePath + "marble.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_PIGMAN_LOWER, basePath + "pigman.png");
+    }
 
-    private final Minecraft mc = Minecraft.getMinecraft();
     private final ModelPlayer model;
     private final ModelBiped modelArmorA;
     private final ModelBiped modelArmorB;
-
+    private final ModelPigman modelPigman;
 
     public TileEntityRendererStatue() {
         this.model = new ModelPlayer(0.0f);
+        this.modelPigman = new ModelPigman(0.0f, 0.0f);
         this.modelArmorA = new ModelBiped(1.0f);
         this.modelArmorB = new ModelBiped(0.5f);
     }
 
-    public void renderAt(TileEntityStatue tileEntity, double x, double y, double z) {
-        TileEntityStatue.Pose pose = tileEntity.getPose();
+    private ModelBiped model(boolean isPigman) {
+        if (isPigman) {
+            return this.modelPigman;
+        } else {
+            return this.model;
+        }
+    }
+
+    public void renderAt(@Nullable ItemStack heldStack, final int meta, final @NotNull Block<?> lowerBlock, final @NotNull TileEntityStatue.Pose pose, final @Nullable IArmorWearing<HumanArmorShape> armorWearer, double x, double y, double z) {
+        final boolean isPigman = lowerBlock == Blocks.STATUE_PIGMAN_LOWER;
 
+        GL12.glEnable(GL12.GL_RESCALE_NORMAL);
         final float scale = 0.0625f;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        loadTexture("/assets/minecraft/textures/entity/statue_stone.png");
+        loadTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
         GL11.glPushMatrix();
-        GL11.glTranslatef((float) x + 0.5f, (float) y + 1.5f, (float) z + 0.5f);
-        float rotation = (float)(tileEntity.getBlockMeta() * 360) / 16F;
+        GL11.glTranslated(x + 0.5, y + 1.5, z + 0.5);
+        float rotation = (float)(meta * 360) / 16F;
         GL11.glRotatef(-rotation, 0.0F, 1.0F, 0.0F);
-        GL11.glScalef(scale, -scale, -scale);
+        GL11.glScalef(1, -1, -1);
         GL11.glDisable(GL11.GL_CULL_FACE);
-        renderModel(this.model, pose);
-        for (int i = 0; i < 4; i++) {
-            renderArmor(tileEntity, i, pose);
-        }
+
+            GL11.glPushMatrix();
+            GL11.glScalef(scale, scale, scale);
+            renderModel(this.model(isPigman), pose);
+            if (armorWearer != null) {
+                for (int i = 0; i < 4; i++) {
+                    renderArmor(armorWearer, i, pose);
+                }
+            }
+            GL11.glPopMatrix();
+
+        renderHeldItem(heldStack, isPigman);
         GL11.glEnable(GL11.GL_CULL_FACE);
         GL11.glPopMatrix();
+        GL12.glDisable(GL12.GL_RESCALE_NORMAL);
+    }
+
+    private void renderHeldItem(final @Nullable ItemStack itemStack, boolean isPigman) {
+        if(itemStack != null) {
+            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            model(isPigman).armRight.translateTo(0.0625F);
+            GL11.glRotatef(-90, 1, 0, 0);
+            GL11.glScalef(-1, 1, -1);
+            GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
+            ItemModelDispatcher.getInstance().getDispatch(itemStack).render(Tessellator.instance, null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, 1f, 1f, 1f, false);
+            GL11.glEnable(GL11.GL_CULL_FACE);
+            GL12.glDisable(GL12.GL_RESCALE_NORMAL);
+        }
     }
 
     private void applyPose(TileEntityStatue.Pose pose, ModelBiped model) {
@@ -50,12 +103,16 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         model.legRight.xRot = pose.rightLegPitch;
         model.head.xRot = pose.headPitch;
         model.head.yRot = pose.headYaw;
+        if (model instanceof ModelPigman) {
+            ((ModelPigman) model).nose.xRot = pose.headPitch;
+            ((ModelPigman) model).nose.yRot = pose.headYaw;
+        }
     }
 
     private void renderModel(ModelBiped model, TileEntityStatue.Pose pose) {
         final float scale = 1.0f;
 
-        model.setupAnimation(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, scale);
+        model.setupAnimation(null, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, scale, 1f);
         applyPose(pose, model);
 
         model.head.render(scale);
@@ -65,16 +122,19 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         model.legRight.render(scale);
         model.legLeft.render(scale);
         model.hair.render(scale);
+        if (model instanceof ModelPigman) {
+            ((ModelPigman) model).nose.render(scale);
+        }
     }
 
     @Override
     public void doRender(Tessellator tessellator, TileEntityStatue tileEntity, double x, double y, double z,
                          float partialTick) {
-        renderAt(tileEntity, x, y, z);
+        renderAt(tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
     }
 
-    private boolean renderArmor(TileEntityStatue entity, int layer, TileEntityStatue.Pose pose) {
-        ItemStack itemstack = entity.getItemInArmorSlot(HumanArmorShape.values()[(entity.getNumArmorSlots() - 1) - layer]);
+    private boolean renderArmor(final @NotNull IArmorWearing<HumanArmorShape> armorWearer, int layer, TileEntityStatue.Pose pose) {
+        ItemStack itemstack = armorWearer.getItemInArmorSlot(HumanArmorShape.values()[(armorWearer.getNumArmorSlots() - 1) - layer]);
         if (itemstack != null) {
             Item item = itemstack.getItem();
             ModelBiped toDraw = null;
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 10ebc53b9..b1b6991c4 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -16,6 +16,7 @@ import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
+import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.WeatherManager;
 
 public class WorldClient extends World {
@@ -64,7 +65,7 @@ public class WorldClient extends World {
         float r = (float)(color >> 16 & 255) / 255F;
         float g = (float)(color >> 8 & 255) / 255F;
         float b = (float)(color & 255) / 255F;
-        float f6 = getCurrentWeather() != null && getCurrentWeather().isPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
+        float f6 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
         if(f6 > 0.0F)
         {
             float f7 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
@@ -121,7 +122,7 @@ public class WorldClient extends World {
         r *= f2;
         g *= f2;
         b *= f2;
-        float f7 = getCurrentWeather() != null && getCurrentWeather().isPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
+        float f7 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
         if(f7 > 0.0F)
         {
             float f8 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
diff --git a/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
new file mode 100644
index 000000000..6dee67e1c
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
@@ -0,0 +1,128 @@
+package org.useless.dragonfly;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.render.block.model.BlockModel;
+import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+
+public final class DisplayPos {
+    /**
+     * No Transformation, used in cases where a full block is meant to render without a world reference, mostly for legacy code reasons
+     */
+    public static final String NONE = "none";
+    /**
+     * Transformation while the item being rendered in the mob's third person right hand
+     */
+    public static final String THIRD_PERSON_RIGHT_HAND = "thirdperson_righthand";
+    /**
+     * Transformation while the item being rendered in the mob's third person left hand
+     */
+    public static final String THIRD_PERSON_LEFT_HAND = "thirdperson_lefthand";
+    /**
+     * Transformation while the item being rendered in the player's first person right hand
+     */
+    public static final String FIRST_PERSON_RIGHT_HAND = "firstperson_righthand";
+    /**
+     * Transformation while the item being rendered in the player's first person left hand
+     */
+    public static final String FIRST_PERSON_LEFT_HAND = "firstperson_lefthand";
+    /**
+     * Transformation while the item is being rendered in a gui
+     */
+    public static final String GUI = "gui";
+    /**
+     * Transformation while the item is equipped on the head slot (except for actual armor which uses a separate system)
+     */
+    public static final String HEAD = "head";
+    /**
+     * Transformation while the item is in entity form on the ground
+     */
+    public static final String GROUND = "ground";
+    /**
+     * Traditionally refers to the transformation while in an item frame, may end up getting used for the augment table
+     */
+    public static final String FIXED = "fixed";
+    /**
+     * Transformation while in a jar
+     */
+    public static final String JAR = "jar";
+
+
+    public static final DisplayPos DEFAULT_DISPLAY_POS = new DisplayPos(
+        0, 0, 0,
+        0, 0, 0,
+        1f, 1f, 1f);
+
+    public final float tx;
+    public final float ty;
+    public final float tz;
+
+    public final float rx;
+    public final float ry;
+    public final float rz;
+
+    public final float sx;
+    public final float sy;
+    public final float sz;
+
+    public DisplayPos(
+        float tx, float ty, float tz,
+        float rx, float ry, float rz,
+        float sx, float sy, float sz)
+    {
+        this.tx = tx;
+        this.ty = ty;
+        this.tz = tz;
+
+        this.rx = rx;
+        this.ry = ry;
+        this.rz = rz;
+
+        this.sx = sx;
+        this.sy = sy;
+        this.sz = sz;
+    }
+
+    @Override
+    public String toString() {
+        return "DisplayPos{" +
+            "tx=" + tx +
+            ", ty=" + ty +
+            ", tz=" + tz +
+            ", rx=" + rx +
+            ", ry=" + ry +
+            ", rz=" + rz +
+            ", sx=" + sx +
+            ", sy=" + sy +
+            ", sz=" + sz +
+            '}';
+    }
+
+    public static class Serializer implements JsonSerializer<DisplayPos>, JsonDeserializer<DisplayPos> {
+
+        @Override
+        public DisplayPos deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject object = json.getAsJsonObject();
+            float[] rotation = GsonHelper.getAsFloatArray(object.get("rotation"), 3);
+            float[] translation = GsonHelper.getAsFloatArray(object.get("translation"), 3);
+            float[] scale = GsonHelper.getAsFloatArray(object.get("scale"), 3);
+            return new DisplayPos(
+                translation[0] * BlockModelMojangData.BLOCKS_PER_UNIT, translation[1] * BlockModelMojangData.BLOCKS_PER_UNIT, translation[2] * BlockModelMojangData.BLOCKS_PER_UNIT,
+                rotation[0], rotation[1], rotation[2],
+                scale[0], scale[1], scale[2]);
+        }
+
+        @Override
+        public JsonElement serialize(DisplayPos src, Type typeOfSrc, JsonSerializationContext context) {
+            throw new UnsupportedOperationException();
+        }
+    }
+}
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/BlockModelData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/BlockModelData.java
new file mode 100644
index 000000000..eb4a29f80
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/BlockModelData.java
@@ -0,0 +1,10 @@
+package org.useless.dragonfly.data.block;
+
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public interface BlockModelData {
+    @NotNull NamespaceID modelId();
+    @NotNull StaticBlockModel asModel();
+}
